RK-J - Task #3074
Feature # 3024 (Closed): extension 0.92.20 & 0.93: Enable OpenAl answers
Feature # 3061 (Closed): Backend requirements
BE-0.92.20: Allow caching to the OpenAl encrypted secret key.
06/20/2023 08:20 AM - Ayush Khandelwal

Status: Closed Start date: 06/20/2023
Priority: High Due date: 06/23/2023
Assignee: Ayush Khandelwal % Done: 100%
Category: Estimated time: 2.00 hours
Target version: 1-RK-J-1 Spent time: 6.75 hours
Description

1. Go to the login page, https://edutestqa.appspot.com/admin/login

2. Login through 'Admin’ role user.

3. Go to the settings page for OpenAl, https:/edutestga.appspot.com/admin/gnageneration/settings#openAiAnswerConfigForm
4. When we put the secret key, 'something’ and then click on 'Set'. It will go & saved into the datastore.

At the time of calling the OpenAl Answer AP, it will fetch the secret key from the datastore every time. It will increase the load time.
So in order to make it efficient, we have to apply the caching to the openai secret key.

Scheme:

1. If the secret key is newly added then cache it on the server.

2. If someone changed the secret key then update the caching for the secret key.

3. If the secret key is present in the caching then load it from the caching instead of doing the
datastore call.

Open Al API Endpoints:
URL.: http://edutestga.appspot.com/admin/content/api/vi/answer

Method: "POST"
Request Body: (application/json) {
"searchTerm": "Once upon a time"

}

Overview of the API:
If api is enabled & the key is present, then it will give the response from openai. If not then it will return 512 words lorem ipsum.

History

#1 - 06/20/2023 11:32 AM - Md Shahzar
- Status changed from New to In Progress

- % Done changed from 0 to 70

#2 - 06/20/2023 01:15 PM - Md Shahzar
- % Done changed from 70 to 100

#3 - 06/20/2023 01:19 PM - Md Shahzar

- Status changed from In Progress to Resolved

#4 - 06/22/2023 09:56 AM - Ayush Khandelwal
- Status changed from Resolved to Reopened

- % Done changed from 100 to 50

#5 - 06/22/2023 11:02 AM - Md Shahzar

- Status changed from Reopened to In Progress
https://edutestqa.appspot.com/admin/login
https://edutestqa.appspot.com/admin/qnageneration/settings#openAiAnswerConfigForm
http://edutestqa.appspot.com/admin/content/api/v1/answer

#6 - 06/22/2023 11:03 AM - Md Shahzar
- Status changed from In Progress to Resolved

- % Done changed from 50 to 100

#7 - 06/22/2023 11:58 AM - Md Shahzar

- Status changed from Resolved to Review

#8 - 06/22/2023 12:11 PM - Md Shahzar
- Assignee changed from Md Shahzar to Ayush Khandelwal

#9 - 06/22/2023 12:11 PM - Ayush Khandelwal
MR looks good

#10 - 06/22/2023 12:20 PM - Ayush Khandelwal
- Status changed from Review to Feedback

- Assignee changed from Ayush Khandelwal to Md Shahzar

#11 - 06/22/2023 12:53 PM - Md Shahzar
- Assignee changed from Md Shahzar to Ayush Khandelwal

#12 - 06/22/2023 12:59 PM - Md Shahzar
- Status changed from Feedback to Reopened

- Assignee changed from Ayush Khandelwal to Md Shahzar

#13 - 06/23/2023 06:22 AM - Md Shahzar

- Status changed from Reopened to In Progress

#14 - 06/23/2023 06:23 AM - Md Shahzar

- Status changed from In Progress to Resolved

#15 - 06/23/2023 06:26 AM - Md Shahzar
- Status changed from Resolved to Review

- Assignee changed from Md Shahzar to Ayush Khandelwal

#16 - 06/23/2023 06:42 AM - Ayush Khandelwal

- Status changed from Review to Reopened

- Assignee changed from Ayush Khandelwal to Md Shahzar
- % Done changed from 100 to 50

MR having some review points.

#17 - 06/23/2023 06:48 AM - Md Shahzar

- Status changed from Reopened to In Progress

#18 - 06/23/2023 06:57 AM - Ayush Khandelwal

Review points:

1. Handle the openai error separately instead of catching it through null pointer exception.

2. Log the openai error as a severe log level.
3. Add the ticket number to the title of the merge request.

#19 - 06/23/2023 07:15 AM - Md Shahzar
- Status changed from In Progress to Resolved

- % Done changed from 50 to 100

#20 - 06/23/2023 07:19 AM - Md Shahzar
- Status changed from Resolved to Review

- Assignee changed from Md Shahzar to Ayush Khandelwal

#21 - 06/23/2023 12:48 PM - Ayush Khandelwal
- Status changed from Review to Feedback

- Assignee changed from Ayush Khandelwal to Md Shahzar

#22 - 06/23/2023 01:38 PM - Md Shahzar
- Assignee changed from Md Shahzar to Ayush Khandelwal

#23 - 07/06/2023 05:39 AM - Ayush Khandelwal
- Status changed from Feedback to Closed

Working as expected
